/*

kHTTPd -- the next generation

Accept connections

*/
/****************************************************************
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2, or (at your option)
 *	any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 ****************************************************************/

/*

Purpose:

AcceptConnections should put all "accepted" connections in the 
"WaitForHeader" queue.

Return value:
	The number of accepted connections
*/


#include "structure.h"
#include "prototypes.h"

int AcceptConnections(int CPU,struct socket *Socket,int Block)
{
	struct http_request *NewRequest;
	struct socket *NewSock;
	int count = 0;
	int error;
	/*
#if 0
	DECLARE_WAITQUEUE(wait,current);
#else	
	struct task_struct *tsk = current;
	struct wait_queue wait;
	wait.task = tsk;
#endif		
*/

	if (Block!=0)
	{
	   if (Socket->sk->tp_pinfo.af_tcp.syn_wait_queue==NULL)
	      return 0;
	}

	error = 0;	
	while (error>=0)
	{
		NewSock = sock_alloc();
		if (NewSock==NULL)
			break;
			
		NewSock->type = Socket->type;
		Socket->ops->dup(NewSock,Socket);
		
	
		error = Socket->ops->accept(Socket,NewSock,Block);
		

		if (error<0)
		{
			sock_release(NewSock);
			break;
		}
		
			
		if (NewSock==NULL)
			break;
		
		
		
		NewRequest = kmalloc(sizeof(struct http_request),GFP_KERNEL); 
		
		if (NewRequest == NULL)
		{
			sock_release(NewSock);
			error = -1;
			break;
		}
		memset(NewRequest,0,sizeof(struct http_request));
		
		NewRequest->sock = NewSock;
		
		NewRequest->Next = WaitForHeaderQueue[CPU];
		
		NewRequest->sleep.task = current;
		
		add_wait_queue(NewSock->sk->sleep,&(NewRequest->sleep));
	
		WaitForHeaderQueue[CPU] = NewRequest;
		
		atomic_inc(&ConnectCount);

	
		count++;
	}		
	
	return count;
}