/*

kHTTPd -- the next generation

Send actual file-data to the connections

*/
/****************************************************************
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2, or (at your option)
 *	any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 ****************************************************************/

/*

Purpose:

Logging() terminates "finished" connections and will eventually log them to a 
userspace daemon.

Return value:
	The number of requests that changed status
*/

#include <linux/kernel.h>
#include <linux/skbuff.h>
#include <net/tcp.h>

#include <asm/uaccess.h>

#include "structure.h"
#include "prototypes.h"


int Logging(int CPU)
{
	struct http_request *CurrentRequest,*Req;
	int count = 0;
	
	CurrentRequest = LoggingQueue[CPU];
	
	/* For now, all requests are removed immediatly, but this can change
	   when userspace-logging is added. */
	   
	while (CurrentRequest!=NULL)
	{

		Req = CurrentRequest->Next;

		CleanUpRequest(CurrentRequest);
		
		LoggingQueue[CPU] = Req;
			
		CurrentRequest = Req;
	
		count++;
	}
	return count;
}



void StopLogging(int CPU)
{
	struct http_request *CurrentRequest;
	
	CurrentRequest = LoggingQueue[CPU];
	
	while (CurrentRequest!=NULL)
	{
		CleanUpRequest(CurrentRequest);
		CurrentRequest=CurrentRequest->Next;		
		schedule();
	}
}