/*

kHTTPd -- the next generation

Basic socket interface

*/
/****************************************************************
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2, or (at your option)
 *	any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 ****************************************************************/

#include <linux/kernel.h>
#include <linux/net.h>
#include <linux/version.h>
#include <net/sock.h>


struct socket *MainSocket=NULL;


int StartListening(int Port)
{
	struct socket *sock;
	struct sockaddr_in sin;
	int error;
	
	/* First create a socket */
	
	error = sock_create(PF_INET,SOCK_STREAM,IPPROTO_TCP,&sock);
	if (error<0) 
	     printk("Error during creation of socket; terminating\n");



	/* Now bind the socket */
	
	sin.sin_family	     = AF_INET;
	sin.sin_addr.s_addr  = INADDR_ANY;
	sin.sin_port         = htons(Port);
	
	error = sock->ops->bind(sock,(struct sockaddr*)&sin,sizeof(sin));
	if (error<0)
	{
		printk("Error binding socket \n");
		return 0;	
	}
	
	sock->sk->reuse   = 1;
	sock->sk->nonagle = 0;
	sock->sk->linger  = 1;

	/* Now, start listening on the socket */
	
	/* I have no idea what a good backlog-value is. */
	
	error=sock->ops->listen(sock,32);	
	if (error!=0)
		printk("Error listening on socket \n");
	sock->flags |= SO_ACCEPTCON;	
	
	MainSocket = sock;
	return 1; 
}	

void StopListening(void)
{
	struct socket *sock;
	
	if (MainSocket==NULL) return;
	
	sock=MainSocket;
	
	MainSocket = NULL;
	sock_release(sock);

}