#ifndef _INCLUDE_GUARD_STRUCTURE_H_
#define _INCLUDE_GUARD_STRUCTURE_H_

#include <linux/time.h>
#include <linux/wait.h>

struct http_request;

struct http_request
{
	/* Linked list */
	struct http_request *Next;
	
	/* Network and File data */
	struct socket	*sock;
	struct file	*filp;
	
	int		FileLength;
	int		Time;
	int		IMS_Time;
	int		BytesSent;
	
	/* Wait queue */
	
	struct wait_queue sleep;
	
	
	/* Request information */
	int		IsForUserspace;
	char		TimeS[64];
	char		LengthS[14];
	
	
	char		FileName[256];
	int		FileNameLength;
	char		Agent[128];	
	char		IMS[128];
	char		Host[128];
};


struct http_time
{
	time_t 	UnixTime;
	char	MimeTime[256];
};

struct async_sendfile;

struct async_sendfile
{
	struct async_sendfile	*Next;		/* For linked lists */
	
	struct file	*filp;			/* The source-file */
	struct socket	*sock;			/* The destination socket */
	
	int 	*Pos;				/* The current position within
							filp */
	int	*Length;			/* The end-value of Pos */
	
	
	size_t	page_cache;			/* Should be set to 0 */
	struct page *page;			/* """" */
	struct page **hash;			/* """" */
	struct inode *inode;
	
	struct wait_queue sleep;
	struct wait_queue *clientsleep;
	
};

#endif